﻿# -*- coding: utf-8 -*-
# -*- Python -*-
import sys
import Tkinter as tk
import time
import os
import stat
import re
import image_finder_class
import types
import string
import codecs
import unicodedata
import tkMessageBox

""" variables definition            """
LIST_TYPE_INP = 0
LIST_TYPE_REF = 1

RTC_ACTIVE = 1


""" error message definition        """
error_messege_text_01 = (
    "[ERROR FLISTS] Please press the switch after activation of the RTC.")
error_messege_text_02 = (
    "[ERROR FLISTS] The entry list can not write.")
error_messege_text_03 = (
    "[ERROR FLISTS] The entry list file can not be opened.")

""" state notice message definition """
state_messege_text_01 = (
    "[STATE FLISTS] Registered the entry list of")
state_messege_text_02 = (
    "[STATE FLISTS] Please register the file path of")
state_messege_text_03 = (
    "[STATE FLISTS] The entry of file path information. success!")
state_messege_text_04 = (
    "[STATE FLISTS] The same path information exists.")
state_messege_text_05 = (
    "[STATE FLISTS] The entry list does not exist.")
state_messege_text_06 = (
    "[STATE FLISTS] The file path info is not into the entry list file.")
state_messege_text_07 = (
    "[STATE FLISTS] Path of the directory or file is wrong. please re-check.")
state_messege_text_08 = (
    "[STATE FLISTS] In addition, Japanese characters does not supported.")

""" debug message definition        """
debug_messege_text_01 = (
    "[DEBUG FLISTS] Open Image finder switch click!")
debug_messege_text_02 = (
    "[DEBUG FLISTS] Image file setting switch click!")
debug_messege_text_03 = (
    "[DEBUG FLISTS] Delete select file switch click!")
debug_messege_text_04 = (
    "[DEBUG FLISTS] Delete all switch click!")
debug_messege_text_05 = (
    "[DEBUG FLISTS] Save EntryList switch click!")
debug_messege_text_06 = (
    "[DEBUG FLISTS] Read EntryList switch click!")
debug_messege_text_07 = (
    "[DEBUG FLISTS] Class CreateFileSelector __init__()")
debug_messege_text_08 = (
    "[DEBUG FLISTS] Path information registered to the Entry list.")
debug_messege_text_09 = (
    "[DEBUG FLISTS] Path-> ")


class CreateFileSelector(tk.Frame):

    def __init__(self, r=10, width=500, height=150, master=None):
        print debug_messege_text_07
        tk.Frame.__init__(self, master)
        self.file = "string"
        self.master.title("ImageFileSelectorGUI")

        self.master.resizable(0, 0)

    def set_on_write(self, func1, func2):
        self.on_write1 = func1
        self.on_write2 = func2

    def set_on_reset(self, func):
        self.on_reset = func

    def get_act_trig(self, func):
        self.act_trig_flag = func

    """ The input-image file-related program. """

    def build_widget1(self):
        self.topFrame = tk.LabelFrame(self.master, text="Input file selector")
        self.topFrame.pack(fill=tk.BOTH, expand=1, side=tk.LEFT)

        self.create_browsebutton1()
        self.create_entrylistbox1()
        self.create_setbutton1()
        self.create_setfileframe1()
        self.create_del_filebutton1()
        self.create_delbutton1()
        self.create_writebutton1()
        self.create_readbutton1()

    def create_browsebutton1(self):
        self.browseframe = tk.Frame(self.topFrame)
        self.browseframe.grid(row=1, column=0, padx=5, pady=2,
                              sticky=tk.W, columnspan=1)

        self.browseButton = tk.Button(
            self.browseframe, text=u" Open Image finder ".encode("utf-8"),
            command=lambda: self.click_imagefinder_button(LIST_TYPE_INP), width=20)
        self.browseButton.pack(anchor=tk.W)

    def create_entrylistbox1(self):
        self.listboxframe = tk.LabelFrame(
            self.topFrame, text="EntryList of input file")
        self.listboxframe.grid(row=2, column=0, padx=5, pady=2,
                               sticky=tk.W + tk.E, columnspan=2)

        self.listval = tk.StringVar()
        self.filelistBox1 = tk.Listbox(
            self.listboxframe, listvariable=self.listval, width=50)

        listbox_sb1 = tk.Scrollbar(
            self.listboxframe, orient="v", command=self.filelistBox1.yview)
        listbox_sb2 = tk.Scrollbar(
            self.listboxframe, orient="h", command=self.filelistBox1.xview)

        self.filelistBox1.configure(yscrollcommand=listbox_sb1.set)
        self.filelistBox1.configure(xscrollcommand=listbox_sb2.set)

        self.filelistBox1.grid(
            row=0, column=0, sticky=tk.W + tk.E + tk.N + tk.S)
        listbox_sb1.grid(row=0, column=2, sticky=tk.N + tk.S)
        listbox_sb2.grid(row=1, column=0, sticky=tk.W + tk.E)

    def create_setbutton1(self):
        self.setButtonframe = tk.Frame(self.topFrame)
        self.setButtonframe.grid(row=3, column=0, padx=5, pady=5,
                                 sticky=tk.W, columnspan=1)

        self.setButton = tk.Button(
            self.setButtonframe, text=u"  Image file setting  "
                .encode("utf-8"),
            command=lambda: self.click_setbutton(LIST_TYPE_INP), width=20)
        self.setButton.pack(side=tk.BOTTOM, anchor=tk.W)

    def create_setfileframe1(self):
        self.setfile = tk.LabelFrame(self.topFrame, text="Set image file")
        self.setfile.grid(row=4, column=0, padx=5, pady=2,
                          sticky=tk.W + tk.E, columnspan=2)
        self.setfilename1 = tk.StringVar()
        self.setfilename1.set("---")
        self.name = tk.Label(
            self.setfile, textvariable=self.setfilename1, justify=tk.LEFT, wraplength=450)
        self.name.pack(anchor=tk.W)

    def create_del_filebutton1(self):
        self.delButtonframe = tk.Frame(self.topFrame)
        self.delButtonframe.grid(row=5, column=0, padx=5, pady=5,
                                 sticky=tk.W, columnspan=1)

        self.delButton = tk.Button(
            self.delButtonframe, text=u"  Delete select file  "
                .encode("utf-8"),
            command=lambda: self.click_delfilebutton(LIST_TYPE_INP), width=20)
        self.delButton.pack(side=tk.BOTTOM, anchor=tk.W)

    def create_delbutton1(self):
        self.delButtonframe = tk.Frame(self.topFrame)
        self.delButtonframe.grid(row=5, column=1, padx=5, pady=5,
                                 sticky=tk.W, columnspan=1)

        self.delButton = tk.Button(
            self.delButtonframe, text=u"  Delete all  ".encode("utf-8"),
            command=lambda: self.click_delbutton(LIST_TYPE_INP), width=20)
        self.delButton.pack(side=tk.BOTTOM, anchor=tk.W)

    def create_writebutton1(self):
        self.wrtButtonframe = tk.Frame(self.topFrame)
        self.wrtButtonframe.grid(row=6, column=0, padx=5, pady=10,
                                 sticky=tk.W, columnspan=1)

        self.wrtButton = tk.Button(
            self.wrtButtonframe, text=u"  Save EntryList  ".encode("utf-8"),
            command=lambda: self.write_entrylistbutton(LIST_TYPE_INP), width=20)
        self.wrtButton.pack(side=tk.BOTTOM, anchor=tk.W)

    def create_readbutton1(self):
        self.redButtonframe = tk.Frame(self.topFrame)
        self.redButtonframe.grid(row=6, column=1, padx=5, pady=10,
                                 sticky=tk.W, columnspan=1)

        self.redButton = tk.Button(
            self.redButtonframe, text=u"  Read EntryList  ".encode("utf-8"),
            command=lambda: self.read_entrylistbutton(LIST_TYPE_INP), width=20)
        self.redButton.pack(side=tk.BOTTOM, anchor=tk.W)

    """ The reference-image file-related program. """

    def build_widget2(self):
        self.topFrame = tk.LabelFrame(
            self.master, text="Reference file selector")
        self.topFrame.pack(fill=tk.BOTH, expand=1, side=tk.LEFT)

        self.create_browsebutton2()
        self.create_entrylistbox2()
        self.create_setbutton2()
        self.create_setfileframe2()
        self.create_del_filebutton2()
        self.create_delbutton2()
        self.create_writebutton2()
        self.create_readbutton2()

    def create_browsebutton2(self):
        self.browseframe = tk.Frame(self.topFrame)
        self.browseframe.grid(row=1, column=0, padx=5, pady=2,
                              sticky=tk.W, columnspan=1)

        self.browseButton = tk.Button(
            self.browseframe, text=u" Open Image finder ".encode("utf-8"),
            command=lambda: self.click_imagefinder_button(LIST_TYPE_REF), width=20)
        self.browseButton.pack(anchor=tk.W)

    def create_entrylistbox2(self):
        self.listboxframe = tk.LabelFrame(
            self.topFrame, text="EntryList of reference file")
        self.listboxframe.grid(row=2, column=0, padx=5, pady=2,
                               sticky=tk.W + tk.E, columnspan=2)

        self.listval = tk.StringVar()
        self.filelistBox2 = tk.Listbox(
            self.listboxframe, listvariable=self.listval, width=50)

        listbox_sb1 = tk.Scrollbar(
            self.listboxframe, orient="v", command=self.filelistBox2.yview)
        listbox_sb2 = tk.Scrollbar(
            self.listboxframe, orient="h", command=self.filelistBox2.xview)

        self.filelistBox2.configure(yscrollcommand=listbox_sb1.set)
        self.filelistBox2.configure(xscrollcommand=listbox_sb2.set)

        self.filelistBox2.grid(
            row=0, column=0, sticky=tk.W + tk.E + tk.N + tk.S)
        listbox_sb1.grid(row=0, column=2, sticky=tk.N + tk.S)
        listbox_sb2.grid(row=1, column=0, sticky=tk.W + tk.E)

    def create_setbutton2(self):
        self.setButtonframe = tk.Frame(self.topFrame)
        self.setButtonframe.grid(row=3, column=0, padx=5, pady=5,
                                 sticky=tk.W, columnspan=1)

        self.setButton = tk.Button(
            self.setButtonframe, text=u"  Image file setting  "
                .encode("utf-8"),
            command=lambda: self.click_setbutton(LIST_TYPE_REF), width=20)
        self.setButton.pack(side=tk.BOTTOM, anchor=tk.W)

    def create_setfileframe2(self):
        self.setfile = tk.LabelFrame(self.topFrame, text="Set image file")
        self.setfile.grid(row=4, column=0, padx=5, pady=2,
                          sticky=tk.W + tk.E, columnspan=2)
        self.setfilename2 = tk.StringVar()
        self.setfilename2.set("---")
        self.name = tk.Label(
            self.setfile, textvariable=self.setfilename2, justify=tk.LEFT, wraplength=450)
        self.name.pack(anchor=tk.W)

    def create_del_filebutton2(self):
        self.delButtonframe = tk.Frame(self.topFrame)
        self.delButtonframe.grid(row=5, column=0, padx=5, pady=5,
                                 sticky=tk.W, columnspan=1)

        self.delButton = tk.Button(
            self.delButtonframe, text=u"  Delete select file  "
                .encode("utf-8"),
            command=lambda: self.click_delfilebutton(LIST_TYPE_REF), width=20)
        self.delButton.pack(side=tk.BOTTOM, anchor=tk.W)

    def create_delbutton2(self):
        self.delButtonframe = tk.Frame(self.topFrame)
        self.delButtonframe.grid(row=5, column=1, padx=5, pady=5,
                                 sticky=tk.W, columnspan=1)

        self.delButton = tk.Button(
            self.delButtonframe, text=u"  Delete all  ".encode("utf-8"),
            command=lambda: self.click_delbutton(LIST_TYPE_REF), width=20)
        self.delButton.pack(side=tk.BOTTOM, anchor=tk.W)

    def create_writebutton2(self):
        self.wrtButtonframe = tk.Frame(self.topFrame)
        self.wrtButtonframe.grid(row=6, column=0, padx=5, pady=10,
                                 sticky=tk.W, columnspan=1)

        self.wrtButton = tk.Button(
            self.wrtButtonframe, text=u"  Save EntryList  ".encode("utf-8"),
            command=lambda: self.write_entrylistbutton(LIST_TYPE_REF), width=20)
        self.wrtButton.pack(side=tk.BOTTOM, anchor=tk.W)

    def create_readbutton2(self):
        self.redButtonframe = tk.Frame(self.topFrame)
        self.redButtonframe.grid(row=6, column=1, padx=5, pady=10,
                                 sticky=tk.W, columnspan=1)

        self.redButton = tk.Button(
            self.redButtonframe, text=u"  Read EntryList  ".encode("utf-8"),
            command=lambda: self.read_entrylistbutton(LIST_TYPE_REF), width=20)
        self.redButton.pack(side=tk.BOTTOM, anchor=tk.W)

# function definition

    def click_imagefinder_button(self, list_type):
        if self.act_trig_flag() == RTC_ACTIVE:
            print debug_messege_text_01

            if list_type == LIST_TYPE_INP:
                self.childwindowtop1 = tk.Toplevel()
                self.childwindowtop1.title("Input image file finder")
                self.browse_window = image_finder_class.OpenImageFinder(
                    self.childwindowtop1)
                self.browse_window.set_callback(self.callback_filelist_box1)
                self.browse_window.pack()
            else:
                self.childwindowtop2 = tk.Toplevel()
                self.childwindowtop2.title("Reference image file finder")
                self.browse_window = image_finder_class.OpenImageFinder(
                    self.childwindowtop2)
                self.browse_window.set_callback(self.callback_filelist_box2)
                self.browse_window.pack()
        else:
            print error_messege_text_01

    def callback_filelist_box1(self, value):
        self.callback_filelist_box(value, LIST_TYPE_INP)

    def callback_filelist_box2(self, value):
        self.callback_filelist_box(value, LIST_TYPE_REF)

    def callback_filelist_box(self, value, list_type):
        # value is unicode
        # check path
        if (self.check_path(value)) == True:
            filelists = self.get_filelist_box(list_type)
            lists = str(filelists)
            # check empty of file lists
            if (self.check_empty_list(lists)) == True:
                # check same path
                if (self.check_same_path(lists, value)) == True:
                    print state_messege_text_04
                else:
                    # check Japanese characters
                    if (self.check_string(value)) == True:
                        print debug_messege_text_08
                        print (debug_messege_text_09 + value)
                        self.set_filelist_box(value, list_type)
                    else:
                        print state_messege_text_07
                        print state_messege_text_08
                        self.filelist_input_error_message()
            else:
                # list empty
                # check Japanese characters
                if (self.check_string(value)) == True:
                    print debug_messege_text_08
                    print (debug_messege_text_09 + value)
                    self.set_filelist_box(value, list_type)
                else:
                    print state_messege_text_07
                    print state_messege_text_08
                    self.filelist_input_error_message()
        else:
            print state_messege_text_07

    def click_setbutton(self, list_type):
        if self.act_trig_flag() == RTC_ACTIVE:
            print debug_messege_text_02

            if list_type == LIST_TYPE_INP:
                get = self.filelistBox1.get(tk.ACTIVE)
                self.filename = get.encode("utf-8")
                self.setfilename1.set(get.encode("utf-8"))
                self.on_write1(self.filename)
            else:
                get = self.filelistBox2.get(tk.ACTIVE)
                self.filename = get.encode("utf-8")
                self.setfilename2.set(get.encode("utf-8"))
                self.on_write2(self.filename)
        else:
            print error_messege_text_01

    def click_delfilebutton(self, list_type):
        if self.act_trig_flag() == RTC_ACTIVE:
            print debug_messege_text_03

            if list_type == LIST_TYPE_INP:
                index = self.filelistBox1.index(tk.ACTIVE)
                select_list = self.filelistBox1.get(index)
                set_im_file = self.setfilename1.get()

                if select_list == set_im_file:
                    self.setfilename1.set("---")

                self.filelistBox1.delete(index, index)
            else:
                index = self.filelistBox2.index(tk.ACTIVE)
                select_list = self.filelistBox2.get(index)
                set_im_file = self.setfilename2.get()

                if select_list == set_im_file:
                    self.setfilename2.set("---")

                self.filelistBox2.delete(index, index)
        else:
            print error_messege_text_01

    def click_delbutton(self, list_type):
        if self.act_trig_flag() == RTC_ACTIVE:
            print debug_messege_text_04

            if list_type == LIST_TYPE_INP:
                self.setfilename1.set("---")
                self.filelistBox1.delete(0, tk.END)
            else:
                self.setfilename2.set("---")
                self.filelistBox2.delete(0, tk.END)
        else:
            print error_messege_text_01

    def write_entrylistbutton(self, list_type):
        if self.act_trig_flag() == RTC_ACTIVE:
            print debug_messege_text_05

            if list_type == LIST_TYPE_INP:
                filelists = self.get_filelist_box(LIST_TYPE_INP)
                entry_list = " input."
                openfile = "entry_list1.dump"
            else:
                filelists = self.get_filelist_box(LIST_TYPE_REF)
                entry_list = " reference."
                openfile = "entry_list2.dump"

            self.change_dumpfile_attributes(openfile)

            lists = str(filelists)
            # check empty of file lists
            if (self.check_empty_list(lists)) == True:
                lists = lists.replace("(", "")
                lists = lists.replace(")", "")
                lists = lists.replace("u'", "")
                lists = lists.replace("'", "")
                lists = lists.replace(", ", "\r\n")
                lists = lists.replace("\\\\", "\\")
                lists = lists.replace(",", "")

                fp = codecs.open(openfile, "w", "utf-8")

                try:
                    fp.write(lists)
                except:
                    print error_messege_text_02
                else:
                    print (state_messege_text_01 + entry_list)

                fp.close()

            else:
                # list empty
                print state_messege_text_05
                print (state_messege_text_02 + entry_list)

        else:
            print error_messege_text_01

    def read_entrylistbutton(self, list_type):
        if self.act_trig_flag() == RTC_ACTIVE:
            print debug_messege_text_06

            if list_type == LIST_TYPE_INP:
                openfile = "entry_list1.dump"
                entry_list = " (input)"
            else:
                openfile = "entry_list2.dump"
                entry_list = " (reference)"

            check_read_flag = 0
            if self.check_file_existence_r(openfile) == True:
                check_read_flag = 1
            else:
                print state_messege_text_05

            if check_read_flag == 1:
                try:
                    lists = open(openfile).readlines()
                except IOError:
                    print error_messege_text_03
                else:
                    list_len = len(lists)
                    if list_len != 0:
                        if openfile == "entry_list1.dump":
                            self.filelistBox1.delete(0, tk.END)
                        else:
                            self.filelistBox2.delete(0, tk.END)

                        for index, list in enumerate(lists):
                            filepath = string.strip(list)
                            if list_type == LIST_TYPE_INP:
                                self.filelistBox1.insert(index, filepath)
                            else:
                                self.filelistBox2.insert(index, filepath)
                        print (state_messege_text_03 + entry_list)
                    else:
                        print state_messege_text_06
        else:
            print error_messege_text_01

    def check_path(self, value):
        if value != "":
            if (os.path.exists(value)) == True:
                return True
            else:
                return False
        else:
            return False

    def check_string(self, value):
        for chr in value:
            # 全角英字/半角ｶﾀｶﾅ/全角カタカナ/○☆※(一部の記号)、ロシア語を判断
            ret = unicodedata.east_asian_width(chr) in ['F', 'H', 'W', 'A']
            if ret == True:
                return False
        return True

    def get_filelist_box(self, list_type):
        if list_type == LIST_TYPE_INP:
            filelists = self.filelistBox1.get(0, tk.END)
            return filelists
        else:
            filelists = self.filelistBox2.get(0, tk.END)
            return filelists

    def set_filelist_box(self, value, list_type):
        if list_type == LIST_TYPE_INP:
            self.filelistBox1.insert(tk.END, value)
        else:
            self.filelistBox2.insert(tk.END, value)

    def check_same_path(self, lists, value):
        lists = lists.encode("utf-8")
        lists = lists.replace("\\\\", "--")
        uvalue = value.encode("utf-8")
        uvalue = uvalue.replace("\\", "--")
        if re.search(uvalue, lists):
            return True
        else:
            return False

    def check_empty_list(self, lists):
        if re.search("\.(bmp|dib|jpg|jpeg|jpe|png|tiff|tif)", lists, re.IGNORECASE):
            return True
        else:
            return False

    def filelist_input_error_message(self):
        tkMessageBox.showerror(
            u"Input error",
            u"Japan language characters included.\n"
            u"Could you please check the directory path "
            u"and image filename.")

    def check_file_existence_r(self, openfile):
        if openfile != "":
            if True == os.path.exists(openfile):
                if True == os.access(openfile, os.R_OK):
                    return True
                else:
                    return False
            else:
                return False
        else:
            return False

    def change_dumpfile_attributes(self, openfile):
        if openfile != "":
            if os.path.exists(openfile) == True:
                if os.access(openfile, os.W_OK) == False:
                    os.chmod(openfile, stat.S_IWRITE)


if __name__ == "__main__":
    print "f = parameter_set()"
    f = CreateFileSelector()
    print "f.pack()"
    f.pack()
    print "f.mainloop()"
    f.mainloop()
