﻿# -*- coding: utf-8 -*-
# -*- Python -*-
import re
import os
import os.path
import Tkinter as tk
import tkFileDialog as tkFD
import unicodedata
import tkMessageBox

""" variables definition            """
""" error message definition        """
error_messege_text_01 = (
    "[ERROR FINDER] Path of the directory is wrong. please re-enter the path.")

""" state notice message definition """
state_messege_text_01 = (
    "[STATE FINDER] Path of the directory or file is wrong. please re-check.")
state_messege_text_02 = (
    "[STATE FINDER] In addition, Japanese characters does not supported.")

""" debug message definition        """
debug_messege_text_01 = (
    "[DEBUG FINDER] Initialization of OpenImageFinder class")
debug_messege_text_02 = (
    "[DEBUG FINDER] Open Browser switch click!")
debug_messege_text_03 = (
    "[DEBUG FINDER] Directly entered the directory path.")
debug_messege_text_04 = (
    "[DEBUG FINDER] Directory path-> ")
debug_messege_text_05 = (
    "[DEBUG FINDER] Folder setup of the image file.")
debug_messege_text_06 = (
    "[DEBUG FINDER] Add the path of the image file to the Entry list.")


class OpenImageFinder(tk.Frame):
    """ The main class of this program. """

    def __init__(self, master=None):
        print debug_messege_text_01
        tk.Frame.__init__(self, master)

        self.master.resizable(0, 0)

        frame_dir_path = tk.LabelFrame(
            self, text="Directory path of image file")
        frame_dir_path.pack(anchor=tk.W, padx=10, pady=2)

        self.entrybox_dir = tk.Entry(frame_dir_path, width=50)
        self.entrybox_dir.pack(side=tk.LEFT)
        self.entrybox_dir.bind("<Return>", self.show_filelist)

        self.browse_bottun = tk.Button(
            frame_dir_path, text="Open Browser", command=self.openbrowse)
        self.browse_bottun.pack(side=tk.LEFT, padx=2)

        self.imagefile_up = ImageFileListUpdater(self)

        self.calbackfunc = None

    def openbrowse(self):
        print debug_messege_text_02
        browse_dir = tkFD.askdirectory()
        if len(browse_dir) > 0:
            self.entrybox_dir.delete(0, tk.END)
            self.entrybox_dir.insert(0, browse_dir)
            self.imagefile_up.filelist_update(browse_dir)

    def show_filelist(self, event):
        print debug_messege_text_03
        dirpath = self.entrybox_dir.get()

        if isinstance(dirpath, str) == True:
            # entrybox_dir.get()の戻り値がstrの場合、unicodeに変換
            dirpath = dirpath.decode("utf-8")

        if (self.finder_check_string(dirpath)) == True:
            if (os.path.exists(dirpath)) == True:
                self.imagefile_up.filelist_update(dirpath)
                print (debug_messege_text_04 + dirpath)
            else:
                print error_messege_text_01
                self.imagefile_up.filenamelistBox.delete(0, tk.END)
        else:
            print state_messege_text_01
            print state_messege_text_02
            self.finder_input_error_message()

    def set_callback(self, func):
        self.calbackfunc = func
        self.imagefile_up.set_imagefindcallback(self.calbackfunc)

    def finder_check_string(self, value):
        for chr in value:
            # 全角英字/半角ｶﾀｶﾅ/全角カタカナ/○☆※(一部の記号)、ロシア語を判断
            ret = unicodedata.east_asian_width(chr) in ['F', 'H', 'W', 'A']
            if ret == True:
                return False
        return True

    def finder_input_error_message(self):
        tkMessageBox.showerror(
            u"Input error",
            u"Japan language characters included.\n"
            u"Could you please check the directory path "
            u"and image filename.")


class ImageFileListUpdater:

    def __init__(self, master):
        self.master = master

        self.frame_filelist = tk.LabelFrame(
            self.master, text="Image file list")
        self.frame_filelist.pack(padx=5, pady=5, fill=tk.BOTH, expand=1)
        self.imageFindcallback = None

        self.copyButton = tk.Button(
            self.master, text=u" All Files copy to EntryList  "
                .encode("utf-8"),
            command=lambda: self.click_copybutton(), width=22)
        self.copyButton.pack(padx=5, pady=10, side=tk.BOTTOM, anchor=tk.W)

        self.filenamelistval = tk.StringVar()
        self.filenamelistBox = tk.Listbox(
            self.frame_filelist, listvariable=self.filenamelistval, width=60)

        listbox_sb1 = tk.Scrollbar(
            self.frame_filelist, orient="v", command=self.filenamelistBox.yview)
        listbox_sb2 = tk.Scrollbar(
            self.frame_filelist, orient="h", command=self.filenamelistBox.xview)

        self.filenamelistBox.configure(yscrollcommand=listbox_sb1.set)
        self.filenamelistBox.configure(xscrollcommand=listbox_sb2.set)

        self.filenamelistBox.grid(
            row=0, column=0, sticky=tk.W + tk.E + tk.N + tk.S)

        listbox_sb1.grid(row=0, column=2, sticky=tk.N + tk.S)
        listbox_sb2.grid(row=1, column=0, sticky=tk.W + tk.E)

        self.filenamelistBox.bind("<Double-Button-1>", self.click_namelabel)

    def filelist_update(self, arg_dir_path):
        print debug_messege_text_05
        self.filenamelistBox.delete(0, tk.END)

        dir_imgfilelist = []
        dir_filelist = os.listdir(arg_dir_path)

        for file_name in dir_filelist:
            if re.search("\.(bmp|dib|jpg|jpeg|jpe|png|tiff|tif)$",
                         file_name, re.IGNORECASE):
                fullpath_name = os.path.join(arg_dir_path, file_name)
                dir_imgfilelist.append(fullpath_name)

        for filepath in dir_imgfilelist:
            self.listbox_insert(filepath, arg_dir_path)

    def set_imagefindcallback(self, func):
        self.imageFindcallback = func

    def click_copybutton(self):
        size = self.filenamelistBox.size()

        if size != 0:
            file_count = 0
            for value in range(0, size):
                gets = self.filenamelistBox.get(value)
                fullpath_name = os.path.join(self.arg_dir_path, gets)

                self.ospath = os.path.abspath(fullpath_name)
                if (self.listupdate_check_string(self.ospath)) == True:
                    self.imageFindcallback(self.ospath)
                    self.filenamelistBox.itemconfigure(value, bg="dodgerblue")
                    file_count = file_count + 1
                else:
                    self.filenamelistBox.itemconfigure(value, bg="yellow")

            if size != file_count:
                self.listupdate_input_error_message()

    def listbox_insert(self, arg_imgfile, arg_dir_path):
        self.arg_dir_path = arg_dir_path
        self.imgfile_path = arg_imgfile
        self.file_basename = os.path.basename(self.imgfile_path)

        self.filenamelistBox.insert(tk.END, self.file_basename)

    def click_namelabel(self, event):
        print debug_messege_text_06
        gets = self.filenamelistBox.get(tk.ACTIVE)
        fullpath_name = os.path.join(self.arg_dir_path, gets)

        self.ospath = os.path.abspath(fullpath_name)
        self.imageFindcallback(self.ospath)
        index = self.filenamelistBox.index(tk.ACTIVE)
        if (self.listupdate_check_string(self.ospath)) == True:
            self.filenamelistBox.itemconfigure(index, bg="dodgerblue")
        else:
            self.filenamelistBox.itemconfigure(index, bg="yellow")

    def listupdate_check_string(self, value):
        for chr in value:
            # 全角英字/半角ｶﾀｶﾅ/全角カタカナ/○☆※(一部の記号)、ロシア語を判断
            ret = unicodedata.east_asian_width(chr) in ['F', 'H', 'W', 'A']
            if ret == True:
                return False
        return True

    def listupdate_input_error_message(self):
        tkMessageBox.showerror(
            u"Input error",
            u"Japan language characters included.\n"
            u"Could you please check the directory path "
            u"and image filename.")


if __name__ == "__main__":
    f = OpenImageFinder()
    f.pack()
    f.mainloop()
